package com.qmth.distributed.print.business.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.qmth.distributed.print.business.service.BasicExamService;
import com.qmth.distributed.print.business.service.ConditionService;
import com.qmth.teachcloud.common.entity.BasicExam;
import com.qmth.teachcloud.common.entity.BasicSemester;
import com.qmth.teachcloud.common.service.BasicSemesterService;
import com.qmth.teachcloud.common.util.ServletUtil;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

/**
 * <p>
 * 查询条件 服务实现类
 * </p>
 */
@Service
public class ConditionServiceImpl implements ConditionService {

    @Resource
    BasicSemesterService basicSemesterService;

    @Resource
    BasicExamService basicExamService;

    @Override
    public List<BasicSemester> listSemester(Boolean enable) {
        Long schoolId = Long.valueOf(ServletUtil.getRequestHeaderSchoolId().toString());
        QueryWrapper<BasicSemester> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(BasicSemester::getSchoolId, schoolId);
        if (enable != null) {
            queryWrapper.lambda().eq(BasicSemester::getEnable, enable);
        }
        queryWrapper.lambda().orderByDesc(BasicSemester::getCreateTime);
        return basicSemesterService.list(queryWrapper);
    }

    @Override
    public List<BasicExam> listExam(Long semesterId, Boolean enable) {
        QueryWrapper<BasicExam> queryWrapper = new QueryWrapper<>();
        if (semesterId != null) {
            queryWrapper.lambda().eq(BasicExam::getSemesterId, semesterId);
        }
        if (enable != null) {
            queryWrapper.lambda().eq(BasicExam::getEnable, enable);
        }
        return basicExamService.list(queryWrapper);
    }
}
